/*******************************************************************************
 * Copyright (c) 2015-2018 Skymind, Inc.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Apache License, Version 2.0 which is available at
 * https://www.apache.org/licenses/LICENSE-2.0.
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations
 * under the License.
 *
 * SPDX-License-Identifier: Apache-2.0
 ******************************************************************************/

package org.deeplearning4j.remote.helpers;

import com.google.gson.Gson;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import lombok.NonNull;
import lombok.extern.slf4j.Slf4j;
import org.nd4j.remote.clients.serde.JsonDeserializer;
import org.nd4j.remote.clients.serde.JsonSerializer;

@Data
@AllArgsConstructor
@NoArgsConstructor
public class PredictedPrice {
    private float price;

    public static class PredictedPriceSerializer implements JsonSerializer<PredictedPrice> {
        @Override
        public String serialize(@NonNull PredictedPrice o) {
            return new Gson().toJson(o);
        }
    }

    public static class PredictedPriceDeserializer implements JsonDeserializer<PredictedPrice> {
        @Override
        public PredictedPrice deserialize(@NonNull String json) {
            return new Gson().fromJson(json, PredictedPrice.class);
        }
    }
}
